<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                     |
 |                                                                      |
 | This program is free software. You can redistribute it               |
 | and/or modify it under the terms of the GNU General Public License   |
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of           |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.                         |
 |                                                                      |
 +----------------------------------------------------------------------+
*/


$sql = 'SELECT DISTINCT b.id, b.name FROM data_template_rrd AS a
        INNER JOIN data_template as b
        ON a.data_template_id = b.id
        WHERE a.local_data_id != 0
        ORDER BY b.name';

$data_templates         = array();
$list_of_data_templates = array();
$data_templates         = db_fetch_assoc($sql);
foreach($data_templates as $data_template) {
    $list_of_data_templates[$data_template['id']] = $data_template['name'];
}

?>
